#!/usr/bin/perl
#

# MajorCool is designed to run under Majordomo wrapper control,
# but we need access to some of the httpd/CGI environment
# variables. The sole purpose of this CGI shim is to pass the
# needed variables on the wrapper command line.
# 
# This shim should be installed (or symlinked) in the server's
# cgi-bin. majorcool.pl is the actual Web interface that is invoked
# (which does all the work).

# $HOME is used in the processing of the Majordomo config file
$ENV{HOME} = "/majordomo";

# CGI env-vars needed to pass
@cgi_envs = ( 
	'REMOTE_ADDR',
	'REMOTE_HOST',
	'SERVER_NAME',
	'SERVER_PORT',
	'SCRIPT_NAME',
	'REQUEST_METHOD',
	'QUERY_STRING',
	'CONTENT_LENGTH',
	'DOCUMENT_ROOT',
	'DOCUMENT_NAME',
	'HTTP_COOKIE',
);

# Read and execute the Majordomo .cf file
$cf = $ENV{"MAJORDOMO_CF"} || "/etc/majordomo.cf"; 
die("$cf not readable; stopped") unless -r $cf;
die("inclusion of $cf failed $@") unless require "$cf"; 

# check to see if the cf file is valid
die("listdir not defined. Is majordomo.cf being included correctly?")
	unless defined($listdir);

# Build the environ string
#   'wrapper' does not honor arg separators, so we need to hide
#   any embedded whitespace with URL-style encoding....
foreach (@cgi_envs) {
	local($value) = $ENV{$_};
	next unless $value;
	$value =~ s/\+/%2B/g;		# '+' to hex val
	$value =~ s/ /+/g;		# ' ' to plus
	$env .= " -env '$_=$value'";
}

#print("Content-type: text/plain\n\n$homedir/wrapper majorcool.pl $env");
#system("$homedir/wrapper majorcool.pl $env");
exec("$homedir/wrapper majorcool.pl $env");

